Fixes for Taishan testbed
[csit.git] / resources / libraries / bash / function / artifacts.sh
1 #!/usr/bin/env bash
2
3 # Copyright (c) 2019 Cisco and/or its affiliates.
4 # Copyright (c) 2019 PANTHEON.tech and/or its affiliates.
5 # Licensed under the Apache License, Version 2.0 (the "License");
6 # you may not use this file except in compliance with the License.
7 # You may obtain a copy of the License at:
8 #
9 #     http://www.apache.org/licenses/LICENSE-2.0
10 #
11 # Unless required by applicable law or agreed to in writing, software
12 # distributed under the License is distributed on an "AS IS" BASIS,
13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14 # See the License for the specific language governing permissions and
15 # limitations under the License.
16
17 set -exuo pipefail
18
19 function download_artifacts () {
20     # Get and/or install VPP artifacts from packagecloud.io.
21     #
22     # Variables read:
23     # - CSIT_DIR - Path to existing root of local CSIT git repository.
24     # Variables set:
25     # - REPO_URL - FD.io Packagecloud repository.
26
27     set -exuo pipefail
28
29     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
30         die "Get OS release failed."
31     }
32
33     repo_url_path="${CSIT_DIR}/VPP_REPO_URL"
34     if [ -e "${repo_url_path}" ]; then
35         REPO_URL="$(<${repo_url_path})" || {
36             die "Read repo URL from ${repo_url_path} failed."
37         }
38     else
39         REPO_URL="https://packagecloud.io/install/repositories/fdio/master"
40     fi
41
42     if [ "${os_id}" == "ubuntu" ]; then
43         download_ubuntu_artifacts || die
44     elif [ "${os_id}" == "centos" ]; then
45         download_centos_artifacts || die
46     elif [ "${os_id}" == "opensuse" ]; then
47         download_opensuse_artifacts || die
48     else
49         die "${os_id} is not yet supported."
50     fi
51 }
52
53 function download_ubuntu_artifacts () {
54     # Get and/or install Ubuntu VPP artifacts from packagecloud.io.
55     #
56     # Variables read:
57     # - REPO_URL - FD.io Packagecloud repository.
58     # - VPP_VERSION - VPP version.
59     # - INSTALL - If install packages or download only. Default: download
60
61     set -exuo pipefail
62
63     curl -s "${REPO_URL}"/script.deb.sh | sudo bash || {
64         die "Packagecloud FD.io repo fetch failed."
65     }
66     # If version is set we will add suffix.
67     artifacts=()
68     both_quotes='"'"'"
69     match="[^${both_quotes}]*"
70     qmatch="[${both_quotes}]\?"
71     sed_command="s#.*apt_source_path=${qmatch}\(${match}\)${qmatch}#\1#p"
72     apt_fdio_repo_file=$(curl -s "${REPO_URL}"/script.deb.sh | \
73                          sed -n ${sed_command}) || {
74                              die "Local fdio repo file path fetch failed."
75                          }
76
77     if [ ! -f ${apt_fdio_repo_file} ]; then
78         die "${apt_fdio_repo_file} not found, \
79             repository installation was not successful."
80     fi
81
82     packages=$(apt-cache -o Dir::Etc::SourceList=${apt_fdio_repo_file} \
83                -o Dir::Etc::SourceParts=${apt_fdio_repo_file} dumpavail \
84                | grep Package: | cut -d " " -f 2) || {
85                    die "Retrieval of available VPP packages failed."
86                }
87     if [ -z "${VPP_VERSION-}" ]; then
88         # If version is not specified, find out the most recent version
89         VPP_VERSION=$(apt-cache --no-all-versions show vpp | grep Version: | \
90                       cut -d " " -f 2) || {
91                           die "Retrieval of most recent VPP version failed."
92                       }
93     fi
94
95     set +x
96     for package in ${packages}; do
97         # Filter packages with given version
98         pkg_info=$(apt-cache show ${package}) || {
99             die "apt-cache show on ${package} failed."
100         }
101         ver=$(echo ${pkg_info} | grep -o "Version: ${VPP_VERSION-}[^ ]*" | \
102               head -1) || true
103         if [ -n "${ver-}" ]; then
104             echo "Found '${VPP_VERSION-}' among '${package}' versions."
105             ver=$(echo "$ver" | cut -d " " -f 2)
106             artifacts+=(${package[@]/%/=${ver-}})
107         else
108             echo "Didn't find '${VPP_VERSION-}' among '${package}' versions."
109         fi
110     done
111     set -x
112
113     if [ "${INSTALL:-false}" = true ]; then
114         sudo apt-get -y install "${artifacts[@]}" || {
115             die "Install VPP artifacts failed."
116         }
117     else
118         apt-get -y download "${artifacts[@]}" || {
119             die "Download VPP artifacts failed."
120         }
121     fi
122 }
123
124 function download_centos_artifacts () {
125     # Get and/or install CentOS VPP artifacts from packagecloud.io.
126     #
127     # Variables read:
128     # - REPO_URL - FD.io Packagecloud repository.
129     # - VPP_VERSION - VPP version.
130     # - INSTALL - If install packages or download only. Default: download
131
132     set -exuo pipefail
133
134     curl -s "${REPO_URL}"/script.rpm.sh | sudo bash || {
135         die "Packagecloud FD.io repo fetch failed."
136     }
137     # If version is set we will add suffix.
138     artifacts=()
139     packages=(vpp vpp-selinux-policy vpp-devel vpp-lib vpp-plugins vpp-api-python)
140     if [ -z "${VPP_VERSION-}" ]; then
141         artifacts+=(${packages[@]})
142     else
143         artifacts+=(${packages[@]/%/-${VPP_VERSION-}})
144     fi
145
146     if [ "${INSTALL:-false}" = true ]; then
147         sudo yum -y install "${artifacts[@]}" || {
148             die "Install VPP artifact failed."
149         }
150     else
151         sudo yum -y install --downloadonly --downloaddir=. "${artifacts[@]}" || {
152             die "Download VPP artifacts failed."
153         }
154     fi
155 }
156
157 function download_opensuse_artifacts () {
158     # Get and/or install OpenSuSE VPP artifacts from packagecloud.io.
159     #
160     # Variables read:
161     # - REPO_URL - FD.io Packagecloud repository.
162     # - VPP_VERSION - VPP version.
163     # - INSTALL - If install packages or download only. Default: download
164
165     set -exuo pipefail
166
167     curl -s "${REPO_URL}"/script.rpm.sh | sudo bash || {
168         die "Packagecloud FD.io repo fetch failed."
169     }
170     # If version is set we will add suffix.
171     artifacts=()
172     packages=(vpp vpp-devel vpp-lib vpp-plugins libvpp0)
173     if [ -z "${VPP_VERSION-}" ]; then
174         artifacts+=(${packages[@]})
175     else
176         artifacts+=(${packages[@]/%/-${VPP_VERSION-}})
177     fi
178
179     if [ "${INSTALL:-false}" = true ]; then
180         sudo yum -y install "${artifacts[@]}" || {
181             die "Install VPP artifact failed."
182         }
183     else
184         sudo yum -y install --downloadonly --downloaddir=. "${artifacts[@]}" || {
185             die "Download VPP artifacts failed."
186         }
187     fi
188 }